OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
MEMORY
{
	vectors : o = 0x000000, l = 0x000034
	rom     : o = 0x000034, l = 0x007fcc
	ram     : o = 0x00f780, l = 0x000800
	stack   : o = 0x00ff7e, l = 0x000002
}
SECTIONS 				
{ 					
.vectors : {  } > vectors
rom		: {  } > rom
ram		: {  } > ram
vector	: {  } > vectors

.text    : {
	*(.text) 				
	*(.strings)
	*(.rodata) 				
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > rom
.bss : AT ( LOADADDR(.data) + SIZEOF(.data) ) {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  >ram
.stack : {
	 _stack = . ; 
	*(.stack)
	}  > stack
.stab 0 (NOLOAD) : {
	[ .stab ]
	}
.stabstr 0 (NOLOAD) : {
	[ .stabstr ]
	}
}
