
#include "header3664f_j.h"
#include "sound.c"

void SCI_Init(unsigned long baud);
void SCI_Putchar(unsigned char ch);
void SCI_Print(unsigned char *str);
void SCI_interrupt();

#define SCI_RXBUFSIZE	32
#define DisableINT		asm("orc.b #0xc0,ccr");
#define EnableINT		asm("andc.b #0x3f,ccr");



#define		I2C_SCL		IO.PDR1.BIT.B1
#define		I2C_SDA		IO.PDR1.BIT.B0
#define		I2C_SCL_DIR	IO.PCR1.BIT.B1
#define		I2C_SDA_DIR	IO.PCR1.BIT.B0
#define		I2C_SCLL_SDAL	IO.PDR1.BYTE = 0x00; IO.PCR1.BYTE = 0x03;
#define		I2C_SCLH_SDAL	IO.PDR1.BYTE = 0x00; IO.PCR1.BYTE = 0x01;
#define		I2C_SCLL_SDAH	IO.PDR1.BYTE = 0x00; IO.PCR1.BYTE = 0x02;
#define		I2C_SCLH_SDAH	IO.PDR1.BYTE = 0x00; IO.PCR1.BYTE = 0x00;

#define		MB_LED1	IO.PDR8.BIT.B0
#define		MB_LED2	IO.PDR8.BIT.B1
#define		MB_SW1	IO.PDR8.BIT.B2

#define		MB_SPK	IO.PDR8.BIT.B4





// ===============================================================================================
//    VAʐM
// ===============================================================================================
// 0: 2400bps	1: 4800bps	2: 9600bps	3:19200bps	4:38400bps

unsigned char SCI_BR[5]={ 207, 103, 51, 25, 12 };
unsigned char SCI_rxbuf[SCI_RXBUFSIZE];
unsigned int  SCI_rxbuf_rp,SCI_rxbuf_wp;

void SCI_Init(unsigned long baud) {
	unsigned char status;

	SCI3.SCR3.BYTE = 0x00;						// TE,RENA, NbN\[XI
	SCI3.SMR.BYTE = 0; 							// A8bit,1bit,None, n=0;
	SCI3.BRR = SCI_BR[baud];					// {[[gݒ
//
	SCI3.SCR3.BYTE = 0x70;						// RIE,TE,RE
	SCI_rxbuf_rp = 0;							// Oobt@
	SCI_rxbuf_wp = 1;
	status = SCI3.SSR.BYTE;  SCI3.SSR.BYTE  = 0;
}

void SCI_Putchar(unsigned char ch) {
	if ((SCI3.SCR3.BYTE & 0x20)!=0) {
		while((SCI3.SSR.BYTE & 0x80)==0){};		// TDRE=1ɂȂ܂ő҂
		SCI3.TDR = ch;							// TDRɑMf[^
	}
}

void SCI_Print(unsigned char *str) {
	while(*str != 0) {
		if (*str == 10) { SCI_Putchar(13); }	// LFCR/LF
		SCI_Putchar(*str);
		str++;
	}
}

unsigned int SCI_Getlen() {
	int len;
	len = SCI_rxbuf_wp - ((SCI_rxbuf_rp + 1) & (SCI_RXBUFSIZE - 1));
	if (len<0) { len += SCI_RXBUFSIZE; }
	return len;
}

unsigned char SCI_Getchar() {
	while(SCI_Getlen()==0){};
	SCI_rxbuf_rp = (SCI_rxbuf_rp + 1) & (SCI_RXBUFSIZE - 1);
	return(SCI_rxbuf[SCI_rxbuf_rp]);
}


// ===============================================================================================

void wait(int w) {
	int i,j;
	for(i=0;i<w;i++) {
		for(j=0;j<1000;j++) {			
		}
	}
}

void SCI_hex(unsigned char ch) {
	unsigned char hex[] = "0123456789ABCDEF";
	SCI_Putchar(hex[(ch >> 4) & 15]);
	SCI_Putchar(hex[ ch       & 15]);
}

// ===============================================================================================
//   I2CʐM
// ===============================================================================================

static unsigned char I2C_d;
static unsigned char I2C_c;

void I2C_ChgDat(unsigned char ch) {
	if (ch==0) {
		if (I2C_c == 0) {
			I2C_SCLL_SDAL;
		} else {
			I2C_SCLH_SDAL;
		}
		I2C_d = 0;
	} else {
		if (I2C_c == 0) {
			I2C_SCLL_SDAH;
		} else {
			I2C_SCLH_SDAH;
		}
		I2C_d = 1;
	}
}

void I2C_ChgClk(unsigned char ch) {
	if (ch==0) {
		if (I2C_d == 0) {
			I2C_SCLL_SDAL;
		} else {
			I2C_SCLL_SDAH;
		}
		I2C_c = 0;
	} else {
		if (I2C_d == 0) {
			I2C_SCLH_SDAL;
		} else {
			I2C_SCLH_SDAH;
		}
		I2C_c = 1;
	}
}


void I2C_Start() {
	// oXX^[gtF[Y
	I2C_ChgDat(1);
	I2C_ChgClk(1);			// (1)NbNJ
	wait(1);
	I2C_ChgDat(0);			// (2)NbNJɃf[^LɁioXX^[gj
	wait(1);
}

void I2C_End() {
	// Bus release
	I2C_ChgClk(0);				// NbNL
	I2C_ChgDat(0);				// f[^L
	wait(1);
	I2C_ChgClk(1);				// NbNH
	wait(1);
	I2C_ChgDat(1);				// f[^H
	wait(1);
}


void I2C_Outchar(unsigned char ch,unsigned char ack) {
	int i;

	for(i=0;i<8;i++) {
		I2C_ChgClk(0);			// NbNL
		wait(1);
		if ((ch & 0x80)==0) {	// f[^Zbg
			I2C_ChgDat(0);
		} else {
			I2C_ChgDat(1);
		}
		ch = ch << 1;
		wait(1);
		I2C_ChgClk(1);			// NbNH
		while (I2C_SCL == 0) {}	// NbNL̊ԑ҂
		wait(1);
	}

	// ACK
	MB_LED1 = 0;
	I2C_ChgClk(0);				// NbNL
	I2C_ChgDat(1);				// f[^J
	wait(1);
	while (I2C_SDA == 1) {}		// ACK҂
	I2C_ChgClk(1);				// NbNH
	wait(1);
	MB_LED1 = 1;
}

// --------------

unsigned char I2C_Readchar(unsigned char ack) {
	int i;
	unsigned char ch;

	ch = 0;

	for(i=0;i<8;i++) {
		I2C_ChgClk(0);			// NbNL
		I2C_ChgDat(1);			// f[^쓮
		wait(1);
		ch = ch << 1;			// f[^ǂ
		ch = ch + I2C_SDA;
		wait(1);
		I2C_ChgClk(1);			// NbNH
		wait(1);
	}

	// ACK
	I2C_ChgClk(0);				// NbNL
	if (ack == 0) {
		I2C_ChgDat(1);			// f[^H
	} else {
		I2C_ChgDat(0);			// f[^L
	}
	wait(1);
	I2C_ChgClk(1);				// NbNH
	wait(1);
	return(ch);
}

// ===============================================================================================
//    {
// ===============================================================================================

int main() {
	unsigned char status;
	int i,j,p;
	unsigned char ch;

	// |[g --------------------------------------------------
	// I2C|[g
	IO.PMR1.BYTE      = 0x02;		// P22/TXD̋@\ = TxD
	IO.PUCR1.BYTE     = 0x00;
	IO.PDR1.BYTE      = 0x00;
	IO.PCR1.BYTE      = 0x00;
	I2C_SCLH_SDAH;
	I2C_d = 1;
	I2C_c = 1;

	// }U[{[hytF
	IO.PCR8.BYTE      = 0x13;
	IO.PDR8.BYTE      = 0x00;

	// tO
	asm("nop");
	status = IWPR.BYTE; IWPR.BYTE = 0;
	status = IRR1.BYTE; IRR1.BYTE = 0;
	EnableINT;

	SCI_Init(3);
	SCI_Print("=== System Startup ===\n");

	// ==================================================================
	MB_LED1 = 1;

/*
	wait(1);

	I2C_Start();				// AhX0x00000x59
	I2C_Outchar(0xA0,0);
	I2C_Outchar(0x00,0);
	I2C_Outchar(0x00,0);
	I2C_Outchar(0x59,0);
	I2C_End();
	wait(10);

	I2C_Start();				// AhX0x00010x63
	I2C_Outchar(0xA0,0);
	I2C_Outchar(0x00,0);
	I2C_Outchar(0x01,0);
	I2C_Outchar(0x63,0);
	I2C_End();
	wait(10);

	I2C_Start();				// AhX0x00030xAA
	I2C_Outchar(0xA0,0);
	I2C_Outchar(0x00,0);
	I2C_Outchar(0x03,0);
	I2C_Outchar(0xAA,0);
	I2C_End();
	wait(10);

	I2C_Start();				// AhX0x0000ǂݏo
	I2C_Outchar(0xA0,0);
	I2C_Outchar(0x00,0);
	I2C_Outchar(0x00,0);
	I2C_End();
	I2C_Start();
	I2C_Outchar(0xA1,1);
	ch = I2C_Readchar(1);
	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
	ch = I2C_Readchar(1);
	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
	ch = I2C_Readchar(1);
	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
	ch = I2C_Readchar(1);
	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
	ch = I2C_Readchar(0);
	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
	I2C_End();

//	I2C_Start();
//	I2C_Outchar(0xA1);
//	ch = I2C_Readchar(1);
//	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
//	ch = I2C_Readchar(1);
//	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
//	ch = I2C_Readchar(1);
//	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
//	ch = I2C_Readchar(0);
//	SCI_Print("=== Read : "); SCI_hex(ch); SCI_Print("\n");
//	I2C_End();
*/

	// ^C}PWM[h
	// o̓s: FTIOD
	TW.TMRW.BIT.CTS   = 0;		// JE^X^[g
	TW.TMRW.BIT.BUFEB = 0;
	TW.TMRW.BIT.BUFEA = 0;
	TW.TMRW.BIT.PWMD  = 1;
	TW.TMRW.BIT.PWMC  = 0;
	TW.TMRW.BIT.PWMB  = 0;

	TW.TCRW.BIT.CCLR = 1;
	TW.TCRW.BIT.CKS2 = 0;
	TW.TCRW.BIT.CKS1 = 0;
	TW.TCRW.BIT.CKS0 = 0;
	TW.TCRW.BIT.TOD  = 1;

	TW.TIOR1.BIT.IOD2 = 0;
	TW.TIOR1.BIT.IOD1 = 0;
	TW.TIOR1.BIT.IOD0 = 1;
	
	TW.GRA = 255;
	TW.GRD = 0;
	TW.TMRW.BIT.CTS = 1;		// TCNT X^[g
	
	
	
	for(i=0;i<SOUND_LEN;i++) {
		TW.GRD = sound_dat[i];
		for(j=0;j<18;j++) {}
	}

	while(1) {}
}

// ===============================================================================================
//    荞ݏ[`
// ===============================================================================================

#pragma interrupt
void SCI_interrupt() {
	unsigned char ch,status;
	unsigned int wp;

	ch = SCI3.RDR;
	wp = (SCI_rxbuf_wp+1) & (SCI_RXBUFSIZE-1);
	if (wp != SCI_rxbuf_rp) {
		SCI_rxbuf[SCI_rxbuf_wp] = ch;
		SCI_rxbuf_wp = wp;
	}
	status = SCI3.SSR.BYTE; SCI3.SSR.BYTE = status & 0x87;	// M֘ANA
}
